#ifndef CGIENV_H_
#define CGIENV_H_ 

/*
 * Definition for Environment Class
 * Updated $Date: 1997/03/03 11:07:34 $ by Stig Erik Sand <stig@ii.uib.no>
 *
 * $Log: CgiEnv.H,v $
 * Revision 1.7  1997/03/03 11:07:34  stig
 * Updated for v0.2
 *
 * Revision 1.6  1997/03/01 15:53:30  stig
 * --
 *
 *
 * $Id: CgiEnv.H,v 1.7 1997/03/03 11:07:34 stig Exp stig $
 */

#include <cgi/Defs.H>
#include <stdlib.h>

class CgiEnv {
  friend class CgiData;
public:
  CgiEnv( void );
  ~CgiEnv( void );
    
  const char*    getPath( void )       const { return itsPath; }
  const char*    getPathInfo( void )   const { return itsPathInfo; }
  const char*    getPathTransl( void ) const { return itsPathTransl; }
  const char*    getScriptName( void ) const { return itsScriptName; }

  const char*    getRemHost( void ) const  { return itsRemoteHost; }
  const char*    getRemAddr( void ) const  { return itsRemoteAddr; }
  const char*    getRemUser( void ) const  { return itsRemoteUser; }
  const char*    getRemIdent( void ) const { return itsRemoteIdent; }

  const char*    getReqMethod( void ) const { return itsRequestMethod;}
  const char*    getPostData( void ) const { return itsPostData; }
  const char*    getQueryString( void ) const { return itsQueryString;} 
  const char*    getCookies( void ) const { return itsCookies; }
  
  const char*    getContentType( void ) const { return itsContentType; }
        int      getContentLength( void ) const{
                      return atoi( itsContentLength );
                 }  
  
protected:
  int safeGetEnv( const char *varName, char *&where ) const;
  inline void cleanup(char *variable);

private:
  char *itsServerSoftware, *itsServerName,     *itsGatewayInterface;
  char *itsServerProtocol, *itsServerPort,     *itsRequestMethod;
  char *itsPathInfo,       *itsPathTransl,     *itsScriptName;
  char *itsQueryString,    *itsRemoteHost,     *itsRemoteAddr;
  char *itsAuthType,       *itsRemoteUser,     *itsRemoteIdent;
  char *itsContentType,    *itsAccept,         *itsUserAgent;
  char *itsContentLength,  *itsPostData,       *itsPath;
  char *itsServerAdmin,    *itsCookies;  
};

// Inline Functions

inline void
CgiEnv::cleanup(char *variable) {
  if (MAINT) DEBUGPUT("Wiping out " << variable);
  if (variable) delete[] variable;
};

#endif

