/*
 * Implementation of class CgiEnv
 * Updated $Date: 1997/09/08 08:35:34 $ by Stig Erik Sand <stig@ii.uib.no>
 *
 * $Log: CgiEnv.cpp,v $
 * Revision 1.11  1997/09/08 08:35:34  stig
 * updated for v0.3
 *
 * Revision 1.10  1997/03/03 11:10:51  stig
 * Major update
 *
 * Revision 1.9  1997/03/01 15:52:20  stig
 * --
 *
 *
 * $Id: CgiEnv.cpp,v 1.11 1997/09/08 08:35:34 stig Exp $
 */

#include <stdio.h>
#include <string.h>
#include <cgi/CgiEnv.H>

CgiEnv::CgiEnv(){
  /*SDS
   * Basic constructor for the CgiEnv class
   */

  itsPostData = 0;
  
  safeGetEnv( "SERVER_SOFTWARE", itsServerSoftware );
  safeGetEnv( "SERVER_NAME", itsServerName );
  safeGetEnv( "SERVER_ADMIN", itsServerAdmin );
  safeGetEnv( "GATEWAY_INTERFACE", itsGatewayInterface );
  safeGetEnv( "SERVER_PROTOCOL", itsServerProtocol );
  safeGetEnv( "SERVER_PORT", itsServerPort );
  safeGetEnv( "REQUEST_METHOD", itsRequestMethod );
  safeGetEnv( "PATH", itsPath );
  safeGetEnv( "PATH_INFO", itsPathInfo );
  safeGetEnv( "PATH_TRANSLATED", itsPathTransl );
  safeGetEnv( "SCRIPT_NAME", itsScriptName );
  safeGetEnv( "QUERY_STRING", itsQueryString );
  safeGetEnv( "HTTP_COOKIE", itsCookies );
  safeGetEnv( "REMOTE_HOST", itsRemoteHost );
  safeGetEnv( "REMOTE_ADDR", itsRemoteAddr );
  safeGetEnv( "AUTH_TYPE", itsAuthType );
  safeGetEnv( "REMOTE_USER", itsRemoteUser );
  safeGetEnv( "REMOTE_IDENT", itsRemoteIdent );
  safeGetEnv( "CONTENT_TYPE", itsContentType );
  safeGetEnv( "CONTENT_LENGTH", itsContentLength );
  safeGetEnv( "HTTP_ACCEPT", itsAccept );
  safeGetEnv( "HTTP_USER_AGENT", itsUserAgent );

  if ( noCaseCompare( itsRequestMethod, "get" ) ) {
    DEBUGPUT("GET method recognized");
    if (itsContentLength) delete [] itsContentLength;
    itsContentLength = new char[12];
    sprintf(itsContentLength, "%d", strlen( itsQueryString ));
  }
  else if ( noCaseCompare( itsRequestMethod, "post" ) ) {
    DEBUGPUT("POST method recognized");
    itsPostData = new char[ getContentLength() + 1 ];
    cin.read( itsPostData, getContentLength() );
  }

};

CgiEnv::~CgiEnv( void ){
  /*SDS
   * Cleans up the memory through the cleanup() method
   */
  
   cleanup(itsServerSoftware);     cleanup(itsServerName);
   cleanup(itsGatewayInterface);   cleanup(itsServerProtocol);
   cleanup(itsServerPort);         cleanup(itsRequestMethod);
   cleanup(itsPathInfo);           cleanup(itsPathTransl);
   cleanup(itsScriptName);         cleanup(itsQueryString);
   cleanup(itsRemoteHost);         cleanup(itsRemoteAddr);
   cleanup(itsAuthType);           cleanup(itsRemoteUser);
   cleanup(itsRemoteIdent);        cleanup(itsContentType);
   cleanup(itsAccept);             cleanup(itsUserAgent);
   cleanup(itsContentLength);      cleanup(itsPostData);
   cleanup(itsPath);               cleanup(itsServerAdmin);
   cleanup(itsCookies);
};

int
CgiEnv::safeGetEnv( const char *varName, char *&where ) const {
  /*SDS
   * Safe method for getting environment variables
   */
  
  int len;
  char *temp = getenv(varName);
  if (MAINT) DEBUGPUT("Var: " << varName << " " << temp);
  if (temp)
    len = strlen(temp);
  else
    len = 0;
  
  where = new char[ len + 2 ];
  if (len)
    strcpy(where, temp);
  else
    strcpy(where, "");
  if (MAINT) DEBUGPUT("Var: " << varName << " " << where);
  
  return CGIOK;
};


