/*
 * Implementation of Definitions 
 * Updated $Date: 1997/09/08 08:50:49 $ by Stig Erik Sand <stig@ii.uib.no>
 *
 * $Log: Defs.cpp,v $
 * Revision 1.6  1997/09/08 08:50:49  stig
 * updated for v0.3
 *
 * Revision 1.5  1997/03/03 11:12:18  stig
 * Major update
 *
 *
 * $Id: Defs.cpp,v 1.6 1997/09/08 08:50:49 stig Exp $
 */

#include <string.h>
#include <stdlib.h>
#include <cgi/Defs.H>

FormEntry::FormEntry(){
  /*SDS
   * Basic Constructor
   */
  if (MAINT) DEBUGPUT("Creating Form Entry object");
  attr=NULL; value=NULL; next=NULL;
 
};

FormEntry::FormEntry(const char *attrib, const char *val){
  /*SDS
   * Constructor with starting data
   */
  if (MAINT) DEBUGPUT("Cr. FormEntry: " << attrib << " " << val);

  if (attrib&&strlen(attrib)){
    attr = new char[strlen(attrib)+1];
    strcpy(attr, attrib);
    if (val&&strlen(val)){
      value = new char[strlen(val)+1];
      strcpy(value, val);
    }
    else
      value=NULL;
  }
  else {
    attr=NULL;
    value=NULL;
  }
  next=NULL;
};

FormEntry::FormEntry(const FormEntry &entry){
  /*SDS
   * Copy constructor which simply calls the assignment operator
   */

  *this=entry;
};

FormEntry &
FormEntry::operator=(const FormEntry &entry){
  /*SDS
   * Assignment operator
   */
  
  if (next) delete next;
  if (attr) delete[] attr;
  if (value) delete[] value;
  
  attr = new char[strlen(entry.attr)+1];
  strcpy(attr, entry.attr);
  value = new char[strlen(entry.value)+1];
  strcpy(value, entry.value);
  if (entry.next) next=entry.next;
  else next=0L;
  return *this;
};

FormEntry::~FormEntry(){
  /*SDS
   * Wipes out all allocated data recursively
   */
  
  /*  if (MAINT) {
      DEBUGPUT("Wiping FormEntry..");
      if (next)  DEBUGPUT("Next  is  " << (int)next );
      if (attr)  DEBUGPUT("Attr  is  " << attr );
      if (value) DEBUGPUT("Value is  " << value);
      LINEPUT();
      } */ 
  if (next)  delete   next;
  if (attr)  delete[] attr;
  if (value) delete[] value;
};

int
FormEntry::setvalues(const char *attrib, const char *val){
  /*SDS
   * If there is sensible datas, those are wiped out.
   * attr and value are set to attrib and val.
   */
  if (MAINT) DEBUGPUT("Setting form-values: " <<attrib<< " " <<val);
  if (attr)  delete[] attr;
  if (value) delete[] value;

  if (!(attrib&&strlen(attrib)&&val&&strlen(val))) return 0;
  attr = new char[strlen(attrib)+1];
  strcpy(attr, attrib);
  value = new char[strlen(val)+1];
  strcpy(value, val);
  
  return CGIOK;
};

void
FormEntry::dumpall(void) const {
  /*SDS
   * Debugging function to dump all variables
   */
  
  if (next) next->dumpall();
  if (MAINT) DEBUGPUT("A: " << attr << " -- V: " << value);
}

/* End of Defs.cpp */
